﻿Type=Activity
Version=2.30
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	Dim AStream As AsyncStreams
End Sub

Sub Globals
	Dim txtInput As EditText
	Dim txtLog As EditText
	Dim btnSend As Button
	Dim readings As EditText
	Dim s As String
	Dim size As Int
	Dim confirm As String 
	Dim dimmer As SeekBar
	Dim label1 As Label 
	Dim datatimer As Timer 
	Dim ledvalue As String
	Dim test As String 
	Dim voltage As Double 
	Dim percent As Double 
	Dim percent2 As Int 
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("2")
	readings.Color = Colors.black
	If AStream.IsInitialized = False Then
		'AStream.InitializePrefix(Main.serial1.InputStream, True, Main.serial1.OutputStream, "AStream")
		AStream.Initialize(Main.Serial1.InputStream, Main.Serial1.OutputStream, "AStreams")
	End If
	
	txtLog.Width = 100%x
	dimmer.Initialize("dimmer")
	datatimer.Initialize("datatimer", 50)
End Sub

Sub AStreams_NewData (Buffer() As Byte)
	'LogMessage("", BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
	'Log(Buffer())
 If Buffer.Length >= 8 Then
	s =  BytesToString(Buffer, 0, Buffer.Length, "UTF8")
	
	If s.IndexOf("volt") <> -1 Then
	test = s.SubString(4)
	If IsNumber(test) Then
	voltage = test
	Log(NumberFormat(voltage, 0, 4))
'size = s.Length 
'Log(s)
'Log(test)
'confirm = s.SubString2(4, size - 4)
'If confirm.Length  > 3 Then
'If test.Length > 6 Then
readings.Text = NumberFormat(voltage, 0, 5)
'End If
End If
End If
End If	'readings.Text = BytesToString(Buffer, 4, Buffer.Length - 4, "UTF8")
	'End If
End Sub

Sub AStream_Error
	ToastMessageShow("Connection is broken.", True)
	btnSend.Enabled = False
	txtInput.Enabled = False
End Sub

Sub AStream_Terminated
	AStream_Error
End Sub

Sub Activity_Resume
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		AStream.Close
	End If
End Sub

Sub txtInput_EnterPressed
	If btnSend.Enabled = True Then btnSend_Click
End Sub
Sub btnSend_Click
	AStream.Write(txtInput.Text.GetBytes("UTF8"))
	txtInput.SelectAll
	txtInput.RequestFocus
	'LogMessage("Me", txtInput.Text)
End Sub

Sub LogMessage(From As String, Msg As String)
	txtLog.Text = txtLog.Text & From & ": " & Msg & CRLF
	txtLog.SelectionStart = txtLog.Text.Length
End Sub
Sub LightOn_Click
Dim lighton As String
lighton = "L1"
AStream.Write(lighton.GetBytes("UTF8"))	
End Sub
Sub LightOff_Click
Dim lightoff As String
lightoff = "L0"
AStream.Write(lightoff.GetBytes("UTF8"))	
End Sub
Sub dimmer_ValueChanged (Value As Int, UserChanged As Boolean)


If Value < 100 Then
ledvalue = "dimm"&"0"&Value
'AStream.Write(ledvalue.GetBytes("UTF8"))
percent = Value / 255
percent2 = percent * 100
Log("Percent " & percent & " " & "Percent2 " & percent2)
label1.Text = percent2 & "%"
'label1.Text = "Light Intensity " & Value

datatimer.Enabled = True
Else
ledvalue = "dimm" & Value
'AStream.Write(ledvalue.GetBytes("UTF8"))
percent = Value / 255
percent2 = percent * 100
Log("Percent " & percent & " " & "Percent2 " & percent2)
label1.Text = percent2 & "%"
'label1.Text = "Light Intensity " & Value
datatimer.Enabled = True
End If
End Sub

Sub datatimer_tick
AStream.Write(ledvalue.GetBytes("UTF8"))
datatimer.Enabled = False
End Sub